summaryrefslogtreecommitdiffstats
path: root/knot-resolver/bin/kresd-restart
diff options
context:
space:
mode:
Diffstat (limited to 'knot-resolver/bin/kresd-restart')
-rwxr-xr-xknot-resolver/bin/kresd-restart51
1 files changed, 51 insertions, 0 deletions
diff --git a/knot-resolver/bin/kresd-restart b/knot-resolver/bin/kresd-restart
new file mode 100755
index 0000000..49c2462
--- /dev/null
+++ b/knot-resolver/bin/kresd-restart
@@ -0,0 +1,51 @@
+#!/bin/sh
+
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+HOSTS="${*:-localhost}"
+
+for HOST in ${HOSTS}
+do
+ case "${HOST}" in
+ localhost)
+ NUMBER="$(systemctl | grep -c 'kresd@[0-9].service')"
+
+ for NUMBER in $(seq 1 "${NUMBER}")
+ do
+ echo "Flushing localhost, resolver ${NUMBER}"
+ echo "cache.clear()" | sudo socat - UNIX-CONNECT:/run/knot-resolver/control/"${NUMBER}"
+ done
+ ;;
+
+ *)
+ NUMBER="$(ssh "${HOST}" sudo systemctl | grep -c 'kresd@[0-9].service')"
+
+ for NUMBER in $(seq 1 "${NUMBER}")
+ do
+ echo "Flushing ${HOST}, resolver ${NUMBER}"
+ echo "cache.clear()" | ssh "${HOST}" sudo socat - UNIX-CONNECT:/run/knot-resolver/control/"${NUMBER}"
+ done
+ ;;
+ esac
+done
+
+echo